Subject: {{ "[REGRESSION] " if compared_to_previous.regressions or compared_to_base.regressions else "" }}{{ build["group"].slug }}:{{ build["project"].slug }}:{{ build["build"].version }}

## Kernel
* kernel: {{ build["build"].metadata.make_kernelversion }}
* git repos: {{ build["build"].metadata.git_repo if build["build"].metadata.git_repo is string else build["build"].metadata.git_repo|join(", ") }}
* git branch: {{ build["build"].metadata.git_branch }}
* git commit: {{ build["build"].metadata.git_commit }}
* git describe: {{ build["build"].version }}
* Test details: {{ build_details_url }}
{% if previous  %}


## Compared to build: {{ previous["group"].slug }}:{{ previous["project"].slug }}:{{ previous["build"].version }}

### Regressions
{%   if compared_to_previous.regressions|length == 0 %}

No regressions found.
{%   else %}
{%     for environment in compared_to_previous.regressions %}

Environment "{{ environment }}":
{%       for suite in compared_to_previous.regressions[environment] %}

  Test suite "{{ suite }}":
{%         for test in compared_to_previous.regressions[environment][suite] %}
    * {{ test }}
{%         endfor %}
{%       endfor %}
{%     endfor %}
{%   endif %}

### Fixes
{%   if compared_to_previous.fixes|length == 0 %}

No fixes found.
{%   else %}
{%     for environment in compared_to_previous.fixes %}

Environment "{{ environment }}":
{%       for suite in compared_to_previous.fixes[environment] %}

  Test suite "{{ suite }}":
{%         for test in compared_to_previous.fixes[environment][suite] %}
    * {{ test }}
{%         endfor %}
{%       endfor %}
{%     endfor %}
{%   endif %}
{% endif %}
{% if base  %}


## Compared to build: {{ base["group"].slug }}:{{ base["project"].slug }}:{{ base["build"].version }}

### Regressions
{%   if compared_to_base.regressions|length == 0 %}

No regressions found.
{%   else %}
{%     for environment in compared_to_base.regressions %}

Environment "{{ environment }}":
{%       for suite in compared_to_base.regressions[environment] %}

  Test suite "{{ suite }}":
{%         for test in compared_to_base.regressions[environment][suite] %}
    * {{ test }}
{%         endfor %}
{%       endfor %}
{%     endfor %}
{%   endif %}

### Fixes
{%   if fixes|length == 0 %}

No fixes found.
{%   else %}
{%     for environment in compared_to_base.fixes %}

Environment "{{ environment }}":
{%       for suite in compared_to_base.fixes[environment] %}

  Test suite "{{ suite }}":
{%         for test in compared_to_base.fixes[environment][suite] %}
    * {{ test }}
{%         endfor %}
{%       endfor %}
{%     endfor %}
{%   endif %}
{% endif %}


## Failures for {{ build["group"].slug }}:{{ build["project"].slug }}:{{ build["build"].version }}

{% if build_stats.failures|length > 0 %}
Failed tests ({{ build_stats.failures|length }}):
{%   for environment, suite, test in build_stats.failures %}
 * {{ environment }}: {{ test }}
{%   endfor %}
{% else %}
None.
{% endif %}

## Environments for {{ build["group"].slug }}:{{ build["project"].slug }}:{{ build["build"].version }}

{% if build_stats.environments|length > 0 %}
Test stats per environment:
{%   for environment, stats in build_stats.environments %}
{%     set total = stats.pass + stats.fail + stats.skip + stats.xfail %}
{%     if total == 0 %}{% continue %}{% endif %}
 * {{ environment }}: {{ total }} total{{ ", {0} passed".format(stats.pass) if stats.pass else ""}}{{ ", {0} failed".format(stats.fail) if stats.fail else ""}}{{ ", {0} skipped".format(stats.skip) if stats.skip else ""}}{{ ", {0} xfailed".format(stats.xfail) if stats.xfail else ""}}
{%   endfor %}
{% else %}
None.
{% endif %}

## Suites for {{ build["group"].slug }}:{{ build["project"].slug }}:{{ build["build"].version }}

{% if build_stats.suites|length > 0 %}
Test stats per suite:
{%   for suite, stats in build_stats.suites %}
{%     set total = stats.pass + stats.fail + stats.skip + stats.xfail %}
 * {{ suite }}: {{ total }} total{{ ", {0} passed".format(stats.pass) if stats.pass else ""}}{{ ", {0} failed".format(stats.fail) if stats.fail else ""}}{{ ", {0} skipped".format(stats.skip) if stats.skip else ""}}{{ ", {0} xfailed".format(stats.xfail) if stats.xfail else ""}}
{%   endfor %}
{% else %}
None.
{% endif %}

-- 
Linaro LKFT
https://lkft.linaro.org
